--[[----------------------------------------------------------------------]]--
--[[              Fairy made by Killer HAHA (Robbis_1)               ]]--
--[[ Idea by CapsAdmin and originally made for his server ]]--
--[[----------------------------------------------------------------------]]--

CreateClientConVar("fairy_name", "", true, true)
CreateClientConVar("fairy_color_r", "", true, true)
CreateClientConVar("fairy_color_g", "", true, true)
CreateClientConVar("fairy_color_b", "", true, true)

local matLight 		= Material("sprites/light_ignorez")
local matBeam		= Material("effects/lamp_beam")
local matParticle	= "effects/yellowflare"

ENT.RenderGroup 	= RENDERGROUP_BOTH

include('shared.lua')

function ENT:Initialize()
	self.PixVis = util.GetPixelVisibleHandle()
	
	local R, G, B, A = self:GetColor()
	self.R = R
	self.G = G
	self.B = B
	self.LightSize = 16
	self.LightSizeDelay = 0
end

function ENT:Draw()
	self.BaseClass.Draw(self, true)
end

function ENT:Think()
	local Behaviour = self.Entity:GetNetworkedString("Behavior")
	local Light = DynamicLight(self:EntIndex())
	local Pause = self.Entity:GetNetworkedFloat("Pause")
	local FrameTime = FrameTime()
	
	if (Light) then
		if (Behaviour == "") then
			local R, G, B, A = self:GetColor()
			local App = 700*FrameTime
			
			self.R = math.Approach(self.R, R, App)
			self.G = math.Approach(self.G, G, App)
			self.B = math.Approach(self.B, B, App)
		elseif (Behaviour == "Heal") then
			local App = 500*FrameTime
			self.R = math.Approach(self.R, 150, App)
			self.G = math.Approach(self.G, 150, App)
			self.B = math.Approach(self.B, 255, App)
		elseif (Behaviour == "Light") then
			local App = 500*FrameTime
			self.R = math.Approach(self.R, 255, App)
			self.G = math.Approach(self.G, 255, App)
			self.B = math.Approach(self.B, 255, App)
		elseif (Behaviour == "Attacking") then
			local App = 500*FrameTime
			self.R = math.Approach(self.R, 255, App)
			self.G = math.Approach(self.G, 100, App)
			self.B = math.Approach(self.B, 100, App)
		elseif (Behaviour == "Tell") then
			local R, G, B, A = self:GetColor()
			local App = 300*FrameTime
			
			if (self.White) then
				self.R = math.Approach(self.R, R, App)
				self.G = math.Approach(self.G, G, App)
				self.B = math.Approach(self.B, B, App)
			else
				self.R = math.Approach(self.R, 255, App)
				self.G = math.Approach(self.G, 255, App)
				self.B = math.Approach(self.B, 255, App)
			end
			
			if (self.R == 255) and (self.G == 255) and (self.B == 255) then
				self.White = true
			elseif (self.R == R) and (self.G == G) and (self.B == B) then
				self.White = nil
			end
		elseif (Behaviour == "Leave") or (Behaviour == "Disco") then
			local App = 1000*FrameTime
			self.R = math.Approach(self.R, math.random(0, 255), App)
			self.G = math.Approach(self.G, math.random(0, 255), App)
			self.B = math.Approach(self.B, math.random(0, 255), App)
		end
		
		Light.Pos = self:GetPos()
		Light.r = self.R
		Light.g = self.G
		Light.b = self.B
		if (Pause > CurTime()) then
			Light.Brightness = self:GetBrightness()*0.5
		else
			Light.Brightness = self:GetBrightness()
		end
		Light.Decay = self:GetLightSize() * 5
		Light.Size = self:GetLightSize()
		Light.DieTime = CurTime() + 1
	end
	
	if not (self.Emitter) then
		self.Emitter = ParticleEmitter(self.Entity:GetPos())
	elseif not (self.Entity:IsValid()) then
		self.Emitter:Remove()
	end
	
	if (Pause < CurTime()) and (FrameTime != 0) then
		local Pos = self.Entity:GetPos()
		local Emitter = self.Emitter
		
		if (Emitter) then
			if (Behaviour == "ColorChange") then
				for i = 1, 10 do
					local P = Emitter:Add(matParticle, Pos)
					local Vec = Vector(math.sin(math.random())*2 - 1, math.sin(math.random())*2 - 1, math.sin(math.random())*2 - 1)
					
					P:SetVelocity(Vec * math.random(30, 70))
					P:SetColor(math.random(0, 255), math.random(0, 255), math.random(0, 255))
					P:SetDieTime(math.Rand(10, 15))
					P:SetAirResistance(10)
					P:SetGravity(Vector(0,0,-10))
					P:SetStartAlpha(255)
					P:SetEndAlpha(255)
					P:SetStartSize(3)
					P:SetEndSize(0)
					P:SetCollide(true)
				end
			else
				local P = Emitter:Add(matParticle, Pos)
				local Vec = Vector(math.sin(math.random() * math.Rand(-20, 20)), math.sin(math.random() * math.Rand(-20, 20)), math.sin(math.random() * math.Rand(-20, 20)))
				
				if (Behaviour == "Attacking") then
					P:SetVelocity(Vec * 20)
					P:SetColor(self.R, self.G, self.B)
					P:SetDieTime(math.Rand(1.9, 2.1))
					P:SetAirResistance(10)
					P:SetGravity(Vec * -20)
					P:SetStartAlpha(255)
				elseif (Behaviour == "Leave") or (Behaviour == "Disco") then
					local R = math.Rand(20, 40)
					P:SetVelocity(Vec * R)
					P:SetColor(self.R, self.G, self.B)
					P:SetDieTime(R/10)
					P:SetAirResistance(R/2)
					P:SetGravity(Vec * -R)
					P:SetStartAlpha(self.Alpha or 255)
				else
					P:SetVelocity(Vec * 5)
					P:SetColor(self.R, self.G, self.B)
					P:SetDieTime(math.Rand(0.9, 1.1))
					P:SetAirResistance(0)
					P:SetStartAlpha(255)
				end
				P:SetEndAlpha(0)
				P:SetStartSize(3)
				P:SetEndSize(0)
				P:SetCollide(true)
			end
		end
	end
end

function ENT:DrawTranslucent()
	self.BaseClass.DrawTranslucent(self, true)
	local FrameTime = FrameTime()
	
	local LightPos = self:GetPos()
	render.SetMaterial(matLight)
	
	local ViewNormal = self:GetPos() - EyePos()
	local Distance = ViewNormal:Length()
	ViewNormal:Normalize()

	local R, G, B, A = self:GetColor()
	
	local Visible = util.PixelVisible(LightPos, 4, self.PixVis)	

	if (!Visible) then return end
	
	if (self.Entity:GetNetworkedBool("Laughing")) then
		self.LightSizeDelay = CurTime() + 1.1
		self.Entity.Laughing = true
		self.Entity:SetNetworkedBool("Laughing", false)
	end
	
	if (self.LightSizeDelay > CurTime()) then
		self.LightSize = math.Approach(self.LightSize, 80, 80*FrameTime)
	elseif (self.LightSize != 16) then
		self.LightSize = math.Approach(self.LightSize, 16, 20*FrameTime)
	end
	
	local Size = math.Clamp(Distance * Visible, 64, 256)
	local Pause = self.Entity:GetNetworkedFloat("Pause")
	if (Pause > CurTime()) then
		Size = Size / math.max(1, (Pause - CurTime()) * 10)
		self.LightSize = 0
	end
	
	Distance = math.Clamp(Distance, 32, 800)
	local Col, Alpha
	
	if (self.Entity:GetNetworkedString("Behavior") == "Leave") then
		if not (self.LeaveTime) then
			self.LeaveTime = CurTime()
			self.Alpha = 200
		end
		
		if (self.LeaveTime + 3 < CurTime()) then
			self.Alpha = math.Approach(self.Alpha, 0, 70*FrameTime)
			
			Alpha = math.min(100, self.Alpha)
		end
		
		Col = Color(self.R, self.G, self.B, (Alpha or 100) * Visible)
	else
		Alpha = math.Clamp((1000 - Distance) * Visible, 0, 100)
		Col = Color(self.R, self.G, self.B, Alpha)
	end
	
	render.DrawSprite(LightPos, Size, Size, Col)
	render.DrawSprite(LightPos, Size*0.5, Size*0.5, Col)
	
	render.DrawSprite(LightPos, self.LightSize, self.LightSize, Color(Col.r, Col.g, Col.b, (self.Alpha or 200) * Visible))
end

function ENT:GetOverlayText()
	return self.Entity:GetNetworkedString("Name")
end
