--[[----------------------------------------------------------------------]]--
--[[              Fairy made by Killer HAHA (Robbis_1)               ]]--
--[[ Idea by CapsAdmin and originally made for his server ]]--
--[[----------------------------------------------------------------------]]--

-- SETTINGS --
local Settings = {}
	-- When a player spawns, should a fairy spawn with them?
	-- Warning: This will spawn the fairy with the DEFAULT name and color! 
	Settings.SpawnWithPlayer = false

	-- Shoud it only spawn with admins?
	Settings.SpawnWithPlayerAdminOnly = true

	-- The name it should have when it spawns, if the player doesn't have any own name set
	Settings.SpawnName = "Fairy"
	
	-- The color it should have when it spawns, if the player doesn't have any own color set
	Settings.SpawnColor = Color(255, 170, 255)
	
	-- Every player inside the distance will hear what the fairy says, use 0 or below for unlimited distance
	Settings.TalkDistance = 800
-- SETTINGS --

-- What the fairy should say when...
local Talk = {}

-- FUNNY --
	-- It will laugh at all sentences that contains this word (use lowercase)
	Talk.FunnyWords = {"lol", "hah", "heh", "rofl", "lmao", "xd", "niggers", "mingebag", "4chan", "cdk", "dbs", "robbis", "capsadmin", "faggot", "jimbomcb", "meatspin", "goldmember", "cheeez"}
-- FUNNY --

-- ANNOYING --
Talk.Annoying = {}
	-- A player picks it up (not owner)
	Talk.Annoying.Pickup = "No, stop! What are you doing %s?! =(" -- %s = Player name
-- ANNOYING --

-- NAME --
Talk.Name = {}
	--  It changed the name
	Talk.Name.Change = "My new name is: %s" -- %s = New name
	--  There is no new name
	Talk.Name.None = "What should my new name be?"
	-- That name exists already
	Talk.Name.Exists = "Another fairy is using that name!"
-- NAME --

-- HEALING --
Talk.Heal = {}
	-- It's done healing
	Talk.Heal.Done = "Healing done! =)"

	-- It got no target to heal
	Talk.Heal.Who = "Who should I heal?"

	-- It's on the way to the owner
	Talk.Heal.Self = "I'll get to you as soon as I can!"

	-- The owner doesn't need any healing
	Talk.Heal.SelfNo = "You don't need any healing."

	-- It's on the way to the target 
	Talk.Heal.Other = "I'll get right to %s and heal him!" -- %s = Target name

	-- The target doesn't need any healing
	Talk.Heal.OtherNo = "He don't need any healing."
	
	-- The target is dead
	Talk.Heal.Dead = "I can't revive dead players!"
-- HEALING --

-- COMING --
Talk.Come = {}
	-- It's with the owner already
	Talk.Come.WithYou = "I'm with you already!"
	
	-- It's coming back to the owner
	Talk.Come.Coming = "Coming back to you! =)"
-- COMING --

-- LIGHT --
Talk.Light = {}
	-- It's lighting up the path
	Talk.Light.Light = "I'll do my best!"
-- LIGHT --

-- FOLLOW --
Talk.Follow = {}
	-- It's on it's way to the owner (basically coming back)
	Talk.Follow.Self = Talk.Come.Coming
	
	-- It's on it's way to the target and will follow him
	Talk.Follow.Target = "Following %s..." -- %s = Target name
	
	-- It got no target to follow
	Talk.Follow.Who = "Who should I follow?"
-- FOLLOW --

-- STAY --
Talk.Stay = {}
	-- It's got an order to stay where it is
	Talk.Stay.Wait = "I'll wait here!"
-- STAY --

-- ATTACK --
Talk.Attack = {}
	-- It killed somebody
	Talk.Attack.Kill = "Hah! You're dead %s! >:)" -- %s = Target name
	
	-- It's on it's way to the target player
	Talk.Attack.Attack = "I'll get right on %s!" -- %s = Target name
	
	-- It's trying to attack a dead player
	Talk.Attack.Dead = "%s isn't alive!" -- %s = Target name
	
	-- It's trying to attack a the owner
	Talk.Attack.Owner = "I can't attack you!"
	
	-- There is nothing to attack
	Talk.Attack.Who = "Who should I attack?"
	
	-- Something disturbed the attack, like the fairy hit a wall
	Talk.Attack.Fail = "I can't do this... Coming back."
-- ATTACK --

-- COLOR --
Talk.Color = {}
	-- It changed the color
	Talk.Color.Change = "Paintjob's done in a sec!"
-- COLOR --

-- LEAVE --
Talk.Leave = {}
	-- The fairy is leaving you (part 1)
	Talk.Leave.Leave1 = "Ahh.."
	
	-- The fairy is leaving you (part 2)
	Talk.Leave.Leave2 = "Heheh"
	
	-- The fairy is leaving you (part 3)
	Talk.Leave.Leave3 = "Okey"
	
	-- The fairy is leaving you (part 4)
	Talk.Leave.Leave4 = "aaAAAhHHH-!"
-- LEAVE --

-- TELL --
Talk.Tell = {}
	-- The fairy is on it's way to the player (what it says to you)
	Talk.Tell.OnIt = "I'll get to him with your message as fast as I can!"
	
	-- It's done telling the message
	Talk.Tell.Done = "Message successfully delivered! Coming back."
	
	-- The player tried to send a message to himself
	Talk.Tell.SelfNo = "I can't send a message to YOU..."
	
	-- It hit a wall hard or anything that would make it forget the message
	Talk.Tell.Fail = "I hit something hard and forgot the message... Coming back."
	
	-- There's no player with that name
	Talk.Tell.Who = "There is no player with that name..."
-- TELL --

-- The sounds the fairy uses when it gets hurt/laugh etc.
local Sounds = {}

-- When then fairy got hurt, hit a wall for example
Sounds.Hurt = 	{
				"vo/npc/Alyx/hurt04.wav", 
				"vo/npc/Alyx/hurt06.wav", 
				"vo/npc/Alyx/hurt08.wav"
				}

-- When the fairy laughs
Sounds.Laugh = 	{
				"vo/eli_lab/al_laugh01.wav",
				"vo/k_lab2/al_whee_b.wav",
				"vo/eli_lab/al_laugh02.wav"
				}

-- When a player is picking up the fairy
Sounds.StopIt = {
				"vo/NovaProspekt/al_nostop.wav"
				}

-- When the fairy leaves the players
Sounds.Leave = 	{
				"vo/k_lab/al_woohoo.wav"
				}

-- When the fairy is about to tell/whisper something to a player
Sounds.Tell = 	{
				"vo/trainyard/al_overhere.wav"
				}



-- Do NOT change anything under this line unless you know what you're doing! --
------------------------------------------------------------------------------------------------------

AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include('shared.lua')

local Fairies = {}
for _,t in pairs(Sounds) do
	for _,v in pairs(t) do
		util.PrecacheSound(v)
	end
end


local EntModel = Model("models/props_junk/popcan01a.mdl")
function ENT:Initialize()
	self:SetModel(EntModel)
	self:PhysicsInitSphere(4)
	self:SetCollisionBounds(Vector()*-2, Vector()*2) 
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	self:DrawShadow(false)
	self.PauseTimer = CurTime()
	self.HealDelay = CurTime()
	self.Entity.LastOnPickedUp = CurTime()
	
	local PhysObj = self:GetPhysicsObject()
		
	if (PhysObj:IsValid()) then
		PhysObj:Wake()
		PhysObj:EnableGravity(false)
	end
end

function ENT:MakeTrail(Color)
	if (self.Entity.Trail) and (self.Entity.Trail:IsValid()) then
		self.Entity.Trail:Remove()
	end
	
	self.Entity.Trail = util.SpriteTrail(self.Entity, 0, Color, false, 10, 0, 1, 0.125, "trails/laser.vmt")
end

-- This is the main spawning function
local function SpawnFairy(Ply, Pos, NoPrint)
	local PlyIndex = Ply:EntIndex()
	if (Fairies[PlyIndex]) then
		Fairies[PlyIndex].Num = Fairies[PlyIndex].Num + 1
	else
		Fairies[PlyIndex] = {}
		Fairies[PlyIndex].Num = 1
		Fairies[PlyIndex].Fairies = {}
	end
	
	-- Name
	local Fairyname = Ply:GetInfo("fairy_name")  
	if (Fairyname == "") then
		Fairyname = Settings.SpawnName
	end
	
	if (Fairies[PlyIndex].Num > 1) then
		Fairyname = Fairyname..Fairies[PlyIndex].Num-1
	end
	
	-- Color
	local ColorR, ColorG, ColorB = Ply:GetInfo("fairy_color_r"), Ply:GetInfo("fairy_color_g"), Ply:GetInfo("fairy_color_b")
	if (ColorR == "") or (ColorG == "") or (ColorB == "") then
		ColorR = Settings.SpawnColor.r
		ColorG = Settings.SpawnColor.g
		ColorB = Settings.SpawnColor.b
	end
	
	-- Spawn
	local Ent = ents.Create("gmod_fairy")
	Ent:SetPos(Pos)
	Ent:SetColor(ColorR, ColorG, ColorB, 255)
	Ent:SetBrightness(1)
	Ent:SetLightSize(512)
	Ent:SetNetworkedString("OwnerName", Ply:Name())
	Ent:SetNetworkedString("Name", Fairyname)
	Ent:Spawn()
	Ent:Activate()
	
	Ent.Num = Fairies[PlyIndex].Num
	Ent.Player = Ply
	
	Ent:MakeTrail(Color(ColorR, ColorG, ColorB, 255))
	
	local Index = Ent:EntIndex()
	Fairies[Index] = {}
	Fairies[Index].Name = Fairyname
	Fairies[Index].Owner = Ply
	
	table.insert(Fairies[PlyIndex].Fairies, Index)
	
	if not (NoPrint) then
		Ply:ChatPrint("Fairy spawned with name: " .. Fairyname)
	end
	
	return Ent
end

function ENT:SpawnFunction(Ply, Trace)
	if not (Trace.Hit) then return end
	local Fairy = SpawnFairy(Ply, Trace.HitPos + Trace.HitNormal * 4)
	
	return Fairy
end

local function GetPlayerByName(Ply, TargetName)
	if (TargetName) and (TargetName != "") then
		for k,v in pairs(player.GetAll()) do
			if (string.find(string.lower(v:Name()), TargetName)) then
				return v
			end
		end
	end
end

local function GetFairies(Ply)
	local Index = Ply:EntIndex()
	local t = {}
	local num = 0
	
	if (Fairies[Index]) then
		for k,v in pairs(Fairies[Index].Fairies) do
			local Ent = ents.GetByIndex(v)
			
			if (Ent) and (Ent:IsValid()) then
				local Data = Fairies[v]
				
				if (Data) and (Data.Owner == Ply) then
					t[v] = Data
					num = num + 1
				end
			else
				Fairies[Index].Fairies[v] = nil
			end
		end
	end
	
	return t, num
end

function ENT:Reset()
	self.Entity:SetNetworkedString("Behavior", "")
	self.Entity:SetOwner(NULL)
	self.Entity.HealTarget = nil
	self.Entity.Following = nil
	self.Entity.Attacking = nil
	self.Entity.Stay = nil
	self.Entity.Bring = nil	
	self.Entity.IsLeaving = nil	
	self.Entity.TellTarget = nil	
	
	if (self.Entity:GetLightSize() != 256) then
		self.Entity:SetLightSize(256)
	end
	if (self.Entity:GetBrightness() != 1) then
		self.Entity:SetBrightness(1)
	end
end

local function ChatPrintAll(Text)
	for k,v in pairs(player.GetAll()) do
		v:ChatPrint(Text)
	end
end

function ENT:Talk(Text, Delay, Secret, ToPly)
	Delay = Delay or 0
	local Name = Fairies[self:EntIndex()].Name
	local TotalDelay = 0.1 + Delay + Text:len()/100
	
	if (Secret) then
		ToPly = ToPly or self.Entity.Player
		
		timer.Simple(TotalDelay, ToPly.ChatPrint, ToPly, Name .. ": "..Text)
	else
		if (Settings.TalkDistance > 0) then	
			for k,v in pairs(player.GetAll()) do
				timer.Simple(TotalDelay, function()
					if (v) and (v:IsValid()) and (self.Entity) and (self.Entity:IsValid()) then
						local Length = (v:GetPos() - self.Entity:GetPos()):Length()
						
						if (Length <= Settings.TalkDistance) then
							v:ChatPrint(Name .. ": "..Text)
						end
					end
				end)
			end
		else
			timer.Simple(TotalDelay, ChatPrintAll, Name .. ": "..Text)
		end
	end
	
	return TotalDelay
end

function ENT:Pause(Time)
	self.Entity.PauseTimer = CurTime() + Time
	self.Entity:SetNetworkedFloat("Pause", CurTime() + Time)
end

function ENT:Think()
	if (self.Entity.Player) and not (self.Entity.Player:IsConnected()) then
		self.Entity:Remove()
	end

	if (self.Entity.Player) and (self.Entity.Player:IsValid()) and (self.Entity.Player:Alive()) then
		if (self.Entity.PauseTimer < CurTime()) then
			local Ply = self.Entity.Following or self.Entity.Player
			
			local Behavior = self.Entity:GetNetworkedString("Behavior")
			local Pos 
			if (Behavior == "Heal") and (self.Entity.HealTarget:Alive()) then
				Pos = self.Entity.HealTarget:GetPos()
				Pos.z = Pos.z + 40
			elseif (Behavior == "Light") then
				local Trace = util.QuickTrace(Ply:EyePos(), Ply:GetAimVector() * 200, {Ply, self.Entity})
				
				Pos = Trace.HitPos
			elseif (Behavior == "Attacking") then
				Pos = self.Entity.Attacking:GetPos()
				Pos.z = Pos.z + 40
				
				if not (self.Entity.Attacking:Alive()) then
					self:Reset()
				end
			elseif (Behavior == "Stay") then
				Pos = self.Entity.Stay
			elseif (Behavior == "Tell") then
				Pos = self.Entity.Following:GetPos()
				Pos.z = Pos.z + 62
				
				if ((self.Entity:GetPos() - Pos):Length() < 100) and (self.Entity.TellMessage) then
					self.Entity:EmitSound(Sounds.Tell[math.random(1, #Sounds.Tell)], 60, math.random(125, 135))
					local Delay = self:Talk(self.Entity.TellMessage, 1, true, self.Entity.Following)
					
					timer.Simple(Delay, function()
						self:Talk(Talk.Tell.Done, 0, true)
						self:Reset()
					end)
					
					-- We only wanna call this once...
					self.Entity.TellMessage = nil
				end
			else
				Pos = Ply:GetShootPos()
				local Trace = util.QuickTrace(Pos, Vector(0, 0, 70), {Ply, self.Entity})
				
				Pos.z = Pos.z + Trace.Fraction * 70 - 30
				
				local AimVec = Ply:GetAimVector()
				AimVec.z = AimVec.z/-3
				Pos = Pos + AimVec * -80
				
				if (self.Entity.IsLeaving) then
					Pos = self.Entity.Stay
					
					Pos.x = Pos.x + math.sin(CurTime()) * math.random(-50, 50)
					Pos.y = Pos.y + math.cos(CurTime()) * math.random(-50, 50)
					Pos.z = Pos.z + math.cos(CurTime()) * math.random(-50, 50)
				elseif (self.Entity.IsLaughing) then
					Pos.x = Pos.x + math.sin(CurTime()) * math.random(-250, 250)
					Pos.y = Pos.y + math.cos(CurTime()) * math.random(-250, 250)
					Pos.z = Pos.z + math.cos(CurTime()) * math.random(-250, 250)
				else
					local PlyIndex = self.Entity.Player:EntIndex()
					local Offset = math.rad((self.Num/Fairies[PlyIndex].Num) * 360)
					Pos.x = Pos.x + math.cos(CurTime() + Offset) * math.min(75, 15 + Fairies[PlyIndex].Num * 15)
					Pos.y = Pos.y + math.sin(CurTime() + Offset) * math.min(75, 15 + Fairies[PlyIndex].Num * 15)
					
					Pos.z = Pos.z + math.sin(CurTime()) * 10
				end
			end
			
			local Angle = Pos - self.Entity:GetPos()
			local Distance = Angle:Length()
			local PhysObj = self.Entity:GetPhysicsObject()
			local Velocity = PhysObj:GetVelocity()
			
			if (Behavior == "Heal") and (self.Entity.HealTarget:Alive()) then
				local HP = self.Entity.HealTarget:Health()
				
				if (HP < 100) then
					if (Distance < 20) and (self.Entity.HealDelay < CurTime()) then
						self.Entity.HealTarget:SetHealth(HP + 1)
						
						if (self.Entity:GetLightSize() != 512) then
							self.Entity:SetLightSize(512)
						end
						
						self.Entity.HealDelay = CurTime() + 0.1
					else
						if (self.Entity:GetLightSize() != 256) then
							self.Entity:SetLightSize(256)
						end
					end
				else
					self:Talk(Talk.Heal.Done)
					
					self:Reset()
					
					if (self.Entity:GetLightSize() != 256) then
						self.Entity:SetLightSize(256)
					end
				end
				
				Distance = Distance + 50
			elseif (Behavior == "Light") then
				if (self.Entity.Player:KeyDown(IN_FORWARD)) or (self.Entity.Player:KeyDown(IN_BACKWARD)) then
					Pos.x = Pos.x + math.cos(CurTime()) * math.random(-30, 30)
					Pos.y = Pos.y + math.sin(CurTime()) * math.random(-30, 30)
					
					Angle = (Pos - self.Entity:GetPos())
					
					PhysObj:ApplyForceCenter(Angle * 1.15)
				end
			elseif (Behavior == "Attacking") then
				if (Distance < 30) and (self.Entity.Attacking) then
					local HP = self.Entity.Attacking:Health()
					self.Entity.Attacking:SetHealth(HP - math.random(15, 20))
					
					local Effect = EffectData()
					Effect:SetOrigin(self.Entity:GetPos())
					util.Effect("fairy_explosion", Effect)
					
					if (self.Entity.Attacking:Health() > 0) and (self.Entity.Attacking:Alive()) then
						self:Pause(1)
					else
						self:Talk(string.format(Talk.Attack.Kill, self.Entity.Attacking:Name()))
						self.Entity.Attacking:Kill()
						
						self:Pause(2)
						self:Reset()
					end
				end
				
				if (Distance < 500) then
					local D = math.abs(Distance - 500)
					PhysObj:ApplyForceCenter(Angle * D/50 + Velocity/3 * -1)
				end
			end
			
			PhysObj:ApplyForceCenter(Angle * Distance/500 + Velocity/3 * -1)
		else
			local PhysObj = self.Entity:GetPhysicsObject()
			local Velocity = PhysObj:GetVelocity()
			Velocity.z = Velocity.z + 300
			
			PhysObj:ApplyForceCenter(Velocity/15 * -1)
			
			-- Update the pos so it doesn't go back
			if (self.Entity.IsLeaving) then
				self.Entity.Stay = self.Entity:GetPos()
			end
		end
	elseif not (self.Entity.PlayerDead) then
		self.Entity.PlayerDead = true
	else
		local PhysObj = self.Entity:GetPhysicsObject()
		local Velocity = PhysObj:GetVelocity()
		PhysObj:ApplyForceCenter(Velocity/15 * -1)
	end
	
	if (self.Entity.PlayerDead) and (self.Entity.Player:Alive()) then
		self.Entity:SetPos(self.Entity.Player:GetShootPos())
		self.Entity:GetPhysicsObject():EnableMotion(true)
		self.Entity.PlayerDead = nil
		self:Reset()
	end
	
	self.Entity:NextThink(CurTime())
	return true
end


function ENT:OnTakeDamage(DmgInfo)
	self.Entity:TakePhysicsDamage(DmgInfo)
end

function ENT:PhysicsCollide(Data, PhysObj)
	if (Data.Speed > 500) and (Data.DeltaTime > 0.2 ) then
		if (self.Entity.Attacking) then
			self:Talk(Talk.Attack.Fail)
			self:Reset()
		elseif (self.Entity.TellMessage) then
			self:Talk(Talk.Tell.Fail, 0, true)
			self:Reset()
		end
		
		self:Pause(1)
		
		if not (self.Entity.IsLeaving) then
			self.Entity:EmitSound(Sounds.Hurt[math.random(1, #Sounds.Hurt)], 70, math.random(135, 145))
		end
	end
	
	-- We don't want it to try get to a position outside the world
	if (self.Entity.IsLeaving) then
		self.Entity.Stay = Data.HitPos
	end
	
	local LastSpeed = Data.OurOldVelocity:Length()
	local NewVelocity = PhysObj:GetVelocity()
	NewVelocity:Normalize()
	
	LastSpeed = math.max(NewVelocity:Length(), LastSpeed)
	
	local TargetVelocity = NewVelocity * LastSpeed * 0.8
	
	PhysObj:SetVelocity(TargetVelocity)
end

function ENT:OnRemove()
	local Index = self.Entity:EntIndex()
	local PlyIndex = self.Entity.Player:EntIndex()
	
	Fairies[Index] = nil
	
	if (self.Entity.Player:IsConnected()) then
		-- Player is still on the server
		Fairies[PlyIndex].Num = Fairies[PlyIndex].Num - 1
		
		local Num = 0
		for k,v in pairs(Fairies[PlyIndex].Fairies) do
			local Ent = ents.GetByIndex(v)
			
			if (Ent) and (Ent:IsValid()) then
				Num = Num + 1
				Ent.Num = Num
			else
				table.remove(Fairies[PlyIndex].Fairies, v)
			end
		end
	else
		-- The player left or something, doesn't exist anyway
		Fairies[PlyIndex] = nil
	end
end

function ENT:ChangeColor(Color)
	self.Entity:SetColor(Color.r, Color.g, Color.b, 255)
	self:MakeTrail(Color)
	
	self.Entity:Reset()
end


local function PlayerSay(Ply, Text, ToAll)
	-- Funny Words --
	for _,Word in pairs(Talk.FunnyWords) do
		if (string.find(string.lower(Text), Word)) then
			for Index, Data in pairs(Fairies) do
				local Fairy = ents.GetByIndex(Index)
				
				if (Fairy) and (Fairy:IsValid()) then
					if not (Fairy:IsPlayer()) then
						local Distance = (Ply:GetPos() - Fairy:GetPos()):Length()
						
						if (Distance < 700) then
							local Min = math.Rand(0.2, 1)
							local Max = Min + 0.5
							
							timer.Simple(Min, 	function() 
													Fairy:EmitSound(Sounds.Laugh[math.random(1, #Sounds.Laugh)], 60, math.random(135, 150)) 
													Fairy.IsLaughing = true 
													Fairy:SetNetworkedBool("Laughing", true)
												end)
							
							timer.Simple(Max,	function() 
													Fairy.IsLaughing = nil
													Fairy:SetNetworkedBool("Laughing", false)
												end)
						end
					end
				else
					Fairies[Index] = nil
				end
			end
			
			break
		end
	end
	
	-- Chat commands --
	for Index, Data in pairs(GetFairies(Ply)) do
		local Fairy = ents.GetByIndex(Index)
		local Exp = string.Explode(" ", Text)
		local Say = string.lower(Exp[1])
		local All = (Say == "fairies,") or (Say == "fairies")
		
		if (All) or (Say == string.lower(Data.Name) .. ",") or (Say == string.lower(Data.Name)) then
			local Command = string.lower(Exp[2] or "")
			Exp[3] = Exp[3] or ""
			
			-- Namechange --
			if (Command == "name") or (Command == "newname") then
				if (Exp[3] == "") then
					Fairy:Talk(Talk.Name.None)
				else
					-- Make the first letter in uppercase
					local NewName = string.upper(string.sub(Exp[3], 0, -Exp[3]:len())) .. string.sub(Exp[3], 2)
					local Fairies = GetFairies(Ply)
					
					for k,v in pairs(Fairies) do
						-- Make sure we don't use an existing name
						if (v.Name == NewName) then
							Fairy:Talk(Talk.Name.Exists)
							return
						end
					end
					
					Fairy:Talk(string.format(Talk.Name.Change, NewName))
					Fairies[Index].Name = NewName
					Fairy:SetNetworkedString("Name", NewName)
				end
			
			-- Heal --
			elseif (Command == "heal") then
				local TargetName = string.lower(Exp[3])
				local v = GetPlayerByName(Ply, TargetName)
				
				if ((TargetName == "me") or (TargetName == "my")) and (Ply:Alive()) then
					if (Ply:Health() < 100) then
						Fairy:Talk(Talk.Heal.Self)
						Fairy:SetNetworkedString("Behavior", "Heal")
						Fairy.HealTarget = Ply
						Fairy:SetOwner(Ply)
					else
						Fairy:Talk(Talk.Heal.SelfNo)
					end
				elseif (TargetName == "") or not (v) then
					Fairy:Talk(Talk.Heal.Who)
				else
					if (v:Alive()) then
						if (v:Health() < 100) then
							Fairy:Talk(string.format(Talk.Heal.Other, v:Name()))
							Fairy:SetNetworkedString("Behavior", "Heal")
							Fairy.HealTarget = v
							Fairy:SetOwner(v)
						else
							Fairy:Talk(Talk.Heal.OtherNo)
						end
					else
						Fairy:Talk(Talk.Heal.Dead)
					end
				end
			
			-- Come --
			elseif (Command == "come") then
				if (Fairy:GetNetworkedString("Behavior") == "") and not (Fairy.Following) then
					Fairy:Talk(Talk.Come.WithYou)
				else
					Fairy:Talk(Talk.Come.Coming)
					Fairy:Reset()
				end
			
			-- Light --
			elseif (Command == "light") then
				Fairy:Talk(Talk.Light.Light)
				Fairy:SetNetworkedString("Behavior", "Light")
				
				Fairy:SetLightSize(768)
				Fairy:SetBrightness(1.5)
				
				Fairy:SetOwner(Ply)
			
			-- Follow --
			elseif (Command == "follow") then
				local TargetName = string.lower(Exp[3])
				local v = GetPlayerByName(Ply, TargetName)
				
				if (TargetName == "") or not (v) then
					Fairy:Talk(Talk.Follow.Who)
				else
					if (v == Ply) then
						Fairy:Talk(Talk.Follow.Self)
						Fairy:Reset()
					else
						Fairy:Talk(string.format(Talk.Follow.Target, v:Name()))
						Fairy.Following = v
						Fairy:SetNetworkedString("Behavior", "Following")
					end
				end
			
			-- Stay/Wait --
			elseif (Command == "stay") or (Command == "wait") then
				Fairy:Talk(Talk.Stay.Wait)
				
				Fairy.Stay = Ply:GetShootPos()
				Fairy:SetNetworkedString("Behavior", "Stay")
			
			-- Attack --
			elseif (Command == "attack") then
				local TargetName = string.lower(Exp[3])
				local v = GetPlayerByName(Ply, TargetName)
				
				if (TargetName == "") or not (v) then
					Fairy:Talk(Talk.Attack.Who)
				else
					if (v != Ply) then
						if (v) and (v:Alive()) then
							Fairy:Talk(string.format(Talk.Attack.Attack, v:Name()))
							Fairy.Attacking = v
							Fairy:SetOwner(v)
							Fairy:SetNetworkedString("Behavior", "Attacking")
						else
							Fairy:Talk(string.format(Talk.Attack.Dead, v:Name()))
						end
					else
						Fairy:Talk(Talk.Attack.Owner)
					end
				end
			
			-- Change color/colour --
			elseif (Command == "color") or (Command == "colour") then
				local R = tonumber(Exp[3]) or Ply:GetInfo("fairy_color_r")
				local G = tonumber(Exp[4]) or Ply:GetInfo("fairy_color_g")
				local B = tonumber(Exp[5]) or Ply:GetInfo("fairy_color_b")
				
				if (R == "") then
					R = Settings.SpawnColor.r
				end
				if (G == "") then
					G = Settings.SpawnColor.g
				end
				if (B == "") then
					B = Settings.SpawnColor.b
				end
				
				Fairy:Talk(Talk.Color.Change)
				Fairy:SetNetworkedString("Behavior", "ColorChange")
				
				timer.Simple(0.5, function() Fairy:ChangeColor(Color(R, G, B, 255)) end)
			
			-- Leave --
			elseif (Command == "leave") or (Command == "gtfo") then
				local Pitch = math.random(135, 150)
				Fairy:EmitSound(Sounds.Leave[math.random(1, #Sounds.Leave)], 80, Pitch)
				
				Pitch = math.abs(Pitch/100 - 2)
				Fairy:Talk(Talk.Leave.Leave1)
				timer.Simple(Pitch*1.3, function() Fairy:Talk(Talk.Leave.Leave2) end)
				timer.Simple(Pitch*2.6, function() Fairy:Talk(Talk.Leave.Leave3) end)
				timer.Simple(Pitch*5.3, function() Fairy:Talk(Talk.Leave.Leave4) end)
				
				Fairy:SetNetworkedString("Behavior", "Leave")
				Fairy.IsLeaving = true
				Fairy.Stay = Ply:GetShootPos()
				if (Fairy.Trail) then
					Fairy.Trail:Remove()
					Fairy.Trail = nil
				end
				
				timer.Simple(6, function() Fairy:Remove() end)
			
			-- Tell/Whisper --
			elseif (Command == "tell") or (Command == "whisper") then
				local TargetName = string.lower(Exp[3])
				local v = GetPlayerByName(Ply, TargetName)
				
				if (TargetName == "") or not (v) then
					Fairy:Talk(Talk.Tell.Who, 0, true)
				else
					table.remove(Exp, 1)
					table.remove(Exp, 1)
					table.remove(Exp, 1)
					
					local Message = table.concat(Exp, " ")
					
					if (v == Ply) then
						Fairy:Talk(Talk.Tell.SelfNo, 0, true)
						Fairy:Reset()
					else
						Fairy:Talk(Talk.Tell.OnIt, 0, true)
						Fairy.TellMessage = Message
						Fairy.Following = v -- Using this as a goto player
						Fairy:SetNetworkedString("Behavior", "Tell")
					end
				end
				
				return ""
			
			-- Disco --
			elseif (Command == "disco") then
				Fairy:Talk("IT'S DISCO TIME BAYBEH!!")
				Fairy:SetNetworkedString("Behavior", "Disco")
				Fairy.IsLeaving = true
				Fairy.Stay = Ply:GetShootPos()
			end
			
			-- Bring (IN PROGRESS) --
			-- elseif (Command == "bring") then
				-- local TargetName = Exp[3]
				
				-- for k,v in pairs(player.GetAll()) do
					-- if (string.find(string.lower(v:Name()), TargetName)) then
						-- if (v != Ply) then
							-- if (v:Alive()) then
								-- Fairy:Talk("I'll bring " .. v:Name() .. " to you!")
								-- Fairy.Bring = v
								-- Fairy:SetOwner(v)
								-- Fairy:SetNetworkedString("Behavior", "Bring")
							-- else
								-- Fairy:Talk(v:Name() .. " isn't alive!")
							-- end
						-- else
							-- Fairy:Talk("I can't bring you to yourself!")
						-- end
						
						-- break
					-- end
				-- end
			-- end
			
			-- We're only talking to one fairy, break the loop
			if not (All) then break end
		end
	end
end
hook.Add("PlayerSay", "FairyPlayerSay", PlayerSay)

local function OnPickedUp(Ply, Ent)
	local Index = Ent:EntIndex()
	
	if (Ent:GetClass() == "gmod_fairy") then
		if (Ent.Player == Ply) then
			Ent:EmitSound(Sounds.Laugh[math.random(1, #Sounds.Laugh)], 60, math.random(135, 150))
		elseif (Ent.LastOnPickedUp < CurTime()) then
			Ent:Talk(string.format(Talk.Annoying.Pickup, Ply:Name()))
			Ent:EmitSound(Sounds.StopIt[math.random(1, #Sounds.StopIt)], 60, math.random(135, 150))
			Ent.LastOnPickedUp = CurTime() + 1
		end
	end
end
hook.Add("GravGunOnPickedUp", "FairyGravGunOnPickedUp", OnPickedUp)
hook.Add("PhysgunPickup", "FairyPhysgunPickup", OnPickedUp)


local function PlayerInitialSpawn(Ply)
	if (Settings.SpawnWithPlayer and gmod.GetGamemode().Name == "Sandbox") and ((Ply:IsAdmin()) or Settings.SpawnWithPlayerAdminOnly) then
		SpawnFairy(Ply, Ply:GetShootPos())
	end
end
hook.Add("PlayerInitialSpawn", "SpawnFairy", PlayerInitialSpawn)
